import networkx as nx
import read_graph as rg
import sys
import math
import time
import random
import Queue

def read_nodes_probs(nodes_probs_file):
    node_probs=[]
    f=open(nodes_probs_file,'r')
    lines=f.readlines()
    for line in lines:
        [id,prob]=line.split()
        node_probs.append(eval(prob))
    f.close()
    return node_probs

def read_blockset(blockset_name):
    blockset=[]
    f=open(blockset_name,'r')
    
    lines=f.readlines()
    for line in lines:
        temp=line.split()
        node=int(temp[0])
        blockset.append(node)
    return blockset

def IC_model(g, node_probs,R, blockset):
    num=0
    for i in range(R):
        num=num+run_simulation(g,node_probs, blockset)
    num=num*1.0/R
    return num

def run_simulation(g,node_probs, blockset):
    num=0
    size=len(g)
    isInfluence={}
    for i in range(1,(size+1)):
        isInfluence[str(i)]=False
    
    #int in the queue
    q=Queue.Queue()
    
    for node in blockset:
        isInfluence[str(node)]=True
    
    for i in range(len(node_probs)):
        node=i+1
        ran=random.random()
        if (node_probs[i]>ran):
            isInfluence[str(node)]=True
            q.put(node)
            num=num+1
            
    if q.qsize()!=0:
        node=q.get()
        while True:
            for nb in g[node]:
                if isInfluence[str(nb)]==False:
                    ran=random.random()
                    if ran<g[node][nb]['weight']:
                        q.put(nb)
                        isInfluence[str(nb)]=True
                        num=num+1
            
            if q.qsize()==0:
                break
            else:
                node=q.get()
                    
    return num
    
def main():

    filename=sys.argv[1]
    nodes_probs_file=sys.argv[2]
    K=int(sys.argv[3])
    
    R=int(sys.argv[4])
    
    g=rg.create_undirected_graph_IC(filename)
    
    node_probs=read_nodes_probs(nodes_probs_file)
    
    blockset=[]
    #blockset=read_blockset(blockset_name)
    
    footprint=IC_model(g, node_probs,R, blockset)
    print footprint


if __name__=='__main__':
    main()
